/**************************************************************\
* Copyright (C) 1997 - 2001 Vasile CALMATUI (vasile@wook.com)  *
*                                                              *
* This software is public domain. Permission is granted to     *
* use, copy and modify this software to anyone.                *
****************************************************************
* Please don't contact me for information, bugs, comments, job *
* offers. If you like this software, please send a postcard to *
* the following address:                                       *
* Vasile CALMATUI                                              *
* 35 str. Burebista                                            *
* 3600 Ungheni                                                 *
* MOLDOVA                                                      *
****************************************************************
* The author is not liable for damages resulting from  the use *
* of this software or its derivates.                           *
\**************************************************************/

import java.applet.Applet;
import java.util.*;
import java.awt.*;
import java.net.*;

public class VasSystApplet extends Applet {
  public String getAppletInfo() {
    return (new String("VasSystApplet v1.6 December 10th, 1998, (C) 1997, 1998, 1999, 2000, 2001 Vasile Calmatui"));
  }//getAppletInfo

  //get the information about the computer
  private String getInfo() {
    StringBuffer toReturn=new StringBuffer();
    Toolkit mt=Toolkit.getDefaultToolkit();
    Date md=new Date();
    toReturn.append(
                    "Time="+md.toString()
                    +"\nLocal Time="+md.toLocaleString()
                    +"\nGMT time="+md.toGMTString()
                    );

    String javaVendor=new String(System.getProperty("java.vendor"));
    //to get the IP address of the computer
    //sometimes MSIE gives security exceptions (not caught by Java) and always gives localhost
    //only Netscape and Sun's browser gives IP address
    if(javaVendor.startsWith("Nets") || javaVendor.startsWith("Sun")) {
      try {
        toReturn.append(
                        "\nIPaddress="+InetAddress.getLocalHost().toString()
                        +"\nHostname="+InetAddress.getLocalHost().getHostName()
                        );
      }//try
      catch(Exception k) {toReturn.append("\nIP address not given");}
    }//if
    else {
      toReturn.append("\nIPaddress=localhost/127.0.0.1\nHostname=localhost");
    }//else

    toReturn.append(
                    "\nOS="+System.getProperty("os.name")
                    +"\nOS version="+System.getProperty("os.version")
                    +"\nOS architecture="+System.getProperty("os.arch")
                    +"\nBrowser vendor="+javaVendor
                    +"\nBrowser vendor home="+System.getProperty("java.vendor.url")
                    +"\nJava version="+System.getProperty("java.version")
                    +"\nJava class version="+System.getProperty("java.class.version")
                    +"\nFile separator="+System.getProperty("file.separator")
                    +"\nPath separator="+System.getProperty("path.separator")
                    +"\nLine separator="
                    );

    //to obtain a "beauty" representation of the line separator
    String ls=new String(System.getProperty("line.separator"));
    for(int i=0; i<ls.length(); i++) {
      if(ls.charAt(i)=='\r') toReturn.append("\\r");
      else {
        if(ls.charAt(i)=='\n') toReturn.append("\\n");
        //for other chars, put the numeric representation
        else toReturn.append("\\"+((int)(ls.charAt(i))));
      }//else
    }//for

    toReturn.append(
                    "\nJVM total memory="+Runtime.getRuntime().totalMemory()
                    +"\nJVM free memory="+Runtime.getRuntime().freeMemory()
                    +"\nURL of this page="+getDocumentBase()
                    +"\nRoot of this applet="+getCodeBase()
                    +"\nScreen resolution="+mt.getScreenResolution()+" dots per inch"
                    +"\nScreen size: width="+mt.getScreenSize().width+" height="+mt.getScreenSize().height
                    +"\nApplet's location on the screen: x="+getParent().location().x+" y="+getParent().location().y
                    +"\nNumber of colors: "+mt.getColorModel().getPixelSize()+" bits/pixel, ie "+(int)Math.pow(2, mt.getColorModel().getPixelSize())+" colors"
                    );

    //we get here all the fonts of the system
    String[] fonts=mt.getFontList();
    toReturn.append("\nNumber of Java fonts="+fonts.length+"\nFonts:");
    //and put them in the StringBufffer
    for(int i=0; i<fonts.length; i++) toReturn.append("\n  "+(i+1)+" "+fonts[i]);

    //we get here the name of the applets running in the JVM
    toReturn.append("\nApplets:");
    int j=1;
    for(Enumeration enum=getAppletContext().getApplets(); enum.hasMoreElements();) toReturn.append("\n  "+(j++)+" "+enum.nextElement());

    toReturn.append("\n(C)1997, 1998, 1999, 2000 Vasile Calmatui, vasile@wook.com");
    return toReturn.toString();
  }//getInfo

  public void init() {
    setLayout(null);
    TextArea ta=new TextArea();
    ta.setEditable(false);
    ta.resize(400, 300);
    add(ta);
    ta.appendText(getInfo());
  }//init
}//class VasSystApplet
